<template>
	<a-card :bordered="false">
		<a-form ref="searchFormRef" name="advanced_search" :model="searchFormState" class="ant-advanced-search-form mb-4">
			<a-row :gutter="24">
				<a-col :span="4">
					<a-form-item label="企业客户" name="depotId">
						<a-select v-model:value="searchFormState.depotId" placeholder="请选择企业客户" :options="depotOptions"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-form-item label="出入库" name="depotBizType">
						<a-radio-group v-model:value="searchFormState.depotBizType" placeholder="请选择出入库" :options="depotBizTypeOptions"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-form-item label="粮食种类" name="grainGroup">
						<a-select v-model:value="searchFormState.grainGroup" placeholder="请选择粮食种类" :options="grainGroupOptions"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-form-item label="经办人" name="keeperCitizenId">
						<a-input v-model:value="searchFormState.keeperCitizenId" placeholder="请输入证件号"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-form-item label="车牌" name="licensePlate">
						<a-input v-model:value="searchFormState.licensePlate" placeholder="请输入车牌"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-button type="primary" @click="table.refresh(true)">查询</a-button>
					<a-button style="margin: 0 8px" @click="() => searchFormRef.resetFields()">重置</a-button>
					<!--					<a @click="toggleAdvanced" style="margin-left: 8px">
										{{ advanced ? '收起' : '展开' }}
										<component :is="advanced ? 'up-outlined' : 'down-outlined'"/>
									</a>-->
				</a-col>
			</a-row>
		</a-form>
		<s-table
			ref="table"
			:columns="columns"
			:data="loadData"
			:alert="options.alert.show"
			bordered
			:row-key="(record) => record.id"
			:tool-config="toolConfig"
			:row-selection="options.rowSelection"
		>
			<template #operator class="table-operator">
<!--				<a-space>
					<a-button type="primary" @click="formRef.onOpen()" v-if="hasPerm('depotWorkAdd')">
						<template #icon>
							<plus-outlined/>
						</template>
						新增
					</a-button>
					<a-button danger @click="deleteBatchDepotWork()" v-if="hasPerm('depotWorkBatchDelete')">删除</a-button>
				</a-space>-->
				<a-button type="primary" @click="exportTable()"><export-outlined/>导出</a-button>
			</template>
			<template #bodyCell="{ column, record }">
				<template v-if="column.dataIndex === 'action'">
					<a-space>
						<a @click="formRef.onOpen(record)" v-if="hasPerm('depotWorkEdit')">编辑</a>
						<a-divider type="vertical" v-if="hasPerm(['depotWorkEdit', 'depotWorkDelete'], 'and')"/>
						<a-popconfirm title="确定要删除吗？" @confirm="deleteDepotWork(record)">
							<a-button type="link" danger size="small" v-if="hasPerm('depotWorkDelete')">删除</a-button>
						</a-popconfirm>
					</a-space>
				</template>
			</template>
		</s-table>
	</a-card>
	<Form ref="formRef" @successful="table.refresh(true)"/>
</template>

<script setup name="depotWork">
import {message} from 'ant-design-vue'
import tool from '@/utils/tool'
import Form from './form.vue'
import depotWorkApi from '@/api/biz/depotWorkApi'
import dictOptionsApi from "@/api/biz/dictOptionsApi";
import * as XLSX from "xlsx";
import moment from "moment";

let searchFormState = reactive({})
const searchFormRef = ref()
const table = ref()
const formRef = ref()
const depotOptions = ref([])
const toolConfig = {refresh: true, height: true, columnSetting: true, striped: false}
// 查询区域显示更多控制
const advanced = ref(false)
const toggleAdvanced = () => {
	advanced.value = !advanced.value
}
const columns = [
	{
		title: '企业客户',
		dataIndex: 'depotGrainName'
	},
	{
		title: '出入库',
		dataIndex: 'depotBizType'
	},
	{
		title: '经办人身份证号',
		dataIndex: 'keeperCitizenId'
	},
	{
		title: '粮食种类',
		dataIndex: 'grainGroup'
	},
	{
		title: '数量(吨)',
		dataIndex: 'depotTonCount'
	},
	{
		title: '价格',
		dataIndex: 'depotPrice'
	},
	{
		title: '车牌',
		dataIndex: 'licensePlate'
	},
	{
		title: '出入库时间',
		dataIndex: 'createTime',
		width: '150px'
	},
]
// 操作栏通过权限判断是否显示
if (hasPerm(['depotWorkEdit', 'depotWorkDelete'])) {
	columns.push({
		title: '操作',
		dataIndex: 'action',
		align: 'center',
		width: '150px'
	})
}
let selectedRowKeys = ref([])
// 列表选择配置
const options = {
	alert: {
		show: false,
		clear: () => {
			selectedRowKeys = ref([])
		}
	},
	rowSelection: {
		onChange: (selectedRowKey, selectedRows) => {
			selectedRowKeys.value = selectedRowKey
		}
	}
}
dictOptionsApi.options(Object.assign('', {'dictValue': '粮库'})).then((data) => {
	depotOptions.value = data
})
let loadDataLst
const loadData = (parameter) => {
	const searchFormParam = JSON.parse(JSON.stringify(searchFormState))
	return depotWorkApi.depotWorkPage(Object.assign(parameter, searchFormParam)).then((data) => {
		loadDataLst = data.records
		return data
	})
}
// 删除
const deleteDepotWork = (record) => {
	let params = [
		{
			id: record.id
		}
	]
	depotWorkApi.depotWorkDelete(params).then(() => {
		table.value.refresh(true)
	})
}
// 批量删除
const deleteBatchDepotWork = () => {
	if (selectedRowKeys.value.length < 1) {
		message.warning('请选择一条或多条数据')
		return false
	}
	const params = selectedRowKeys.value.map((m) => {
		return {
			id: m
		}
	})
	depotWorkApi.depotWorkDelete(params).then(() => {
		table.value.clearRefreshSelected()
	})
}
// 导出
const exportTable = () => {
	let tableData = [['企业客户', '预约编号', '还款单号',  '放款单号',  '放款状态',  '出入库', '粮食种类', '粮食类型', '单据类型', '负责人身份证号', '数量（吨）', '价格', '总价'
		, '干粮数量（吨）', '干粮价格（元/吨）', '质量', '车牌', '车次编码', '过毛时间', '过皮时间', '毛重(公斤)', '皮重(公斤)', '净重(公斤)', '入库价格(元/吨)', '潮干比', '干粮水份(%)']]
	let idStr = ''
	if (selectedRowKeys.value.length > 0) {
		selectedRowKeys.value.map((m) => {
			idStr = idStr + ',' + m
		})
	}
	loadDataLst.map((m) => {
		if (!idStr || idStr.indexOf(m.id) > 0)
			tableData.push([m.depotGrainName, m.truckBookId, m.repayOrderNo, m.loanOrderNo, m.loanState, m.depotBizType, m.grainGroup, m.grainType, m.billGroup, m.keeperCitizenId, m.depotTonCount, m.depotPrice, m.orderAmount
				, m.dryTonCount, m.dryPrice, m.depotQuality, m.licensePlate, m.carNumber, m.grossTime, m.tareTime, m.grossWeight, m.tareWeight, m.netWeight, m.samplingPrice, m.dampRatio, m.canonRatio])
	})
	let workSheet = XLSX.utils.aoa_to_sheet(tableData)
	let bookNew = XLSX.utils.book_new()
	XLSX.utils.book_append_sheet(bookNew, workSheet, 'Sheet1')
	let name = '出入库记录' + moment().format('_YYYY-MM-DD') + '.xlsx'
	XLSX.writeFile(bookNew, name)
}
const depotBizTypeOptions = tool.dictList('出入库')
const grainGroupOptions = tool.dictList('粮食种类')
</script>
